
public   class  IntList {
	
    //@ invariant this != null; 
	//@ invariant data != null;
    public int[] data  ;

	public IntList  () {
        data = new int[0];
    }

	/*@
    @ invariant  (\forall int k; 0 <= k && k < data.length-1; data[k] >= data[k+1]); */
/*@
    @ assignable data;
@ ensures (\exists int z; 0 <= z && z < data.length && data[z] == newTop)
    @ && (\forall int k; 0 <= k && k < \old(data).length 
    @    ==> (\exists int z; 0 <= z && z < data.length && data[z] == \old(data[k]))); */
public void push(int newTop) {
		{
        int[] tmp = new int[data.length+1];
        tmp[tmp.length-1] = newTop;
        for(int i = 0; i < data.length; i++) {
            tmp[i] = data[i];
        }
        //@ assert (tmp[tmp.length-1] == newTop);
        //@ assert (\forall int k; 0 <= k && k < data.length; tmp[k] == data[k] && (\exists int z; 0 <= z && z < tmp.length; tmp[z] == data[k]));
        //@ assert (\forall int k; 0 <= k && k < data.length; tmp[k] == data[k] ==> (\exists int z; 0 <= z && z < tmp.length; tmp[z] == data[k]));
        //@ assume (\forall int k; 0 <= k && k < data.length; tmp[k] == data[k] ==> (\exists int z; 0 <= z && z < tmp.length; tmp[z] == data[k]));
        //@ assert (\forall int k; 0 <= k && k < data.length; (\exists int z; 0 <= z && z < tmp.length; tmp[z] == data[k]));
        data = tmp;
    }
		sort();
	}

	public void printContents  () {
    	System.out.print("List contents:");
    	for (int i = 0; i < data.length; i++) {
    		System.out.print(" " + data[i]);
    	}
    	System.out.println();
    }

	/*@
    @ assignable data[0..data.length-1];
@ ensures (\forall int k; 0 <= k && k < data.length-1; data[k] >= data[k+1]); */
private /*@ helper */ void sort() {
		for (int i = 0; i < data.length; i++) {
			/*@ assert (\forall int k; 0 <= k && k < i;
			  @        (\forall int m; k < m && m < data.length; data[k] >= data[m]));
			  @*/
			for (int j = data.length-2; j >= 0; j--) {
				if (data[j] < data[j+1]) {
					int tmp = data[j];
					data[j] = data[j+1];
					data[j+1] = tmp;
				}
				//@ assert data[j] >= data[j+1];
			}
		}
	}


}
